{ lib
, stdenv
, fetchFromGitHub
, gnumake
}:

stdenv.mkDerivation rec {
  pname = "mini-gdbstub";
  version = "2024-07-16";

  src = fetchFromGitHub {
    owner = "xinyangli";
    repo = "mini-gdbstub";
    rev = "c5cec27285a6f3256b7bdd90037840aa1726d379";
    hash = "sha256-ACpmvwlaKNAjkJ/ucDWpWKqayZrc4RZh/G54cGkFo/M=";
  };

  nativeBuildInputs = [
    gnumake
  ];

  installPhase = ''
    mkdir -p $out/lib $out/include
    cp build/libgdbstub.a $out/lib
    cp include/gdbstub.h $out/include
  '';

  meta = with lib; {
    description = "An implementation of the GDB Remote Serial Protocol to help you adding debug mode on emulator";
    homepage = "https://github.com/xinyangli/mini-gdbstub";
    license = licenses.mit;
    maintainers = with maintainers; [ ];
    mainProgram = "mini-gdbstub";
    platforms = platforms.all;
  };
}
